`define INSN_LD8M_A		9'b0111x0000	// 1111 for ld A, x; 1110 for ld x, A; bit 1 specifies 16m8 or 8m8

// If opcode[4], then ld A, x, else ld x, A
// If opcode[1], then ld 16m8, else ld 8m8

`ifdef EXECUTE
	`INSN_LD8M_A: begin
		case (cycle)
		0:	begin
				`EXEC_INC_PC
				`EXEC_READ(`_PC + 16'h0001)
			end
		1:	if (opcode[4])	// LD A,x
				`EXEC_READ(({8'hFF, rdata}))
			else
				`EXEC_WRITE(({8'hFF, rdata}), `_A)
		2:	begin
				`EXEC_NEWCYCLE
				`EXEC_INC_PC
			end
		endcase
	end
`endif

`ifdef WRITEBACK
	`INSN_LD8M_A: begin
		case (cycle)
		0:	begin end
		1:	begin end
		2:	if (opcode[4]) `_A <= rdata;
		endcase
	end
`endif

